@echo off
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
CLS
REM To create a aXPcli.lst from an existing build navigate to ROOT
REM and issue command:
REM DIR /A:D /B /S >aXPcli.lst&DIR /A:-D /B /S>>aXPcli.lst
REM then edit it removing the drive letter and PATH to ROOT
REM and add a # in front of BOOT.INI (if present), directories and aXPcli.lst
REM There is no need for the directories to be at the top but it's easier
REM To add the # to just the few first entries.
ECHO ::Small EXPERIMENTAL batch file to build Dietmar Stoelting's XPCLIBR
ECHO ::From a base by Dennis123123 - modified by jaclaz
ECHO ::Release 0.01 ALPHA - 18 January 2008
ECHO.
ECHO                  ----------------------------------
ECHO                    Dietmar's XPCLIBR - Build tool
ECHO                  ----------------------------------
ECHO.
ECHO This batch will attempt to create the structure for a XPCLIBR build
ECHO from a aXPCLI.lst file, containing a list of needed files.
ECHO.
ECHO There should be a \BaseRegistry directory containing the Registry files:
ECHO DEFAULT
ECHO SAM
ECHO SECURITY
ECHO SOFTWARE
ECHO SYSTEM
ECHO.
ECHO You will also need minlogon.exe from Windows XP Embedded.
ECHO And a CD (or \I386 directory) of "normal" Windows XP
ECHO Right now XP SP0 and SP1 are tested to be working
ECHO.

PAUSE
:Get_ListFile
SET ListFile=aXPcli.lst
ECHO Please type name of list file or press [ENTER] to use default (aXPCLI.lst)
SET /P ListFile=
IF NOT %ListFile:~-4%.==.lst. GOTO :Get_ListFile
IF NOT EXIST "%ListFile%" GOTO :Get_ListFile

cd /d %~dp0

:CHECKFILES
SET MISSING_FLAG=0
FOR %%A IN (
minlogon.exe
.\BaseRegistry\DEFAULT
.\BaseRegistry\SAM
.\BaseRegistry\SECURITY
.\BaseRegistry\SOFTWARE
.\BaseRegistry\SYSTEM
) DO If not exist %%A CALL :MissingFile %%A
IF %MISSING_FLAG%==1 GOTO :CHECKFILES
 

ECHO Please insert a Windows XP (SP1) CD now.
PAUSE

SET CDROM=
FOR %%A IN (D E F G H I J K L M N O P Q R S T U V W X Y Z) DO IF EXIST %%A:\WIN51 SET Source=%%A:\I386

:No_Source
IF NOT DEFINED Source CALL :Get_Source

echo Source XP files found in %Source%

pause

IF EXIST %~dp0ROOT (
ECHO Warning existing directory structure will be deleted!
ECHO.
RD /S %~dp0ROOT
)
IF NOT EXIST %~dp0ROOT MD %~dp0ROOT 
Pushd %~dp0ROOT

echo Extracting files...

echo [boot loader]>BOOT.INI
echo timeout=10>>BOOT.INI
echo default=multi(0)disk(0)rdisk(0)partition(1)\WINDOWS>>BOOT.INI
echo [operating systems]>>BOOT.INI
echo multi(0)disk(0)rdisk(0)partition(1)\WINDOWS="Microsoft Windows XP1 Dietmar's CLI">>BOOT.INI

FOR /F %%A IN (%~dp0%ListFile%) DO (
ECHO %%A>>xpcli.log
CALL :Copy_or_Expand %%A
)


copy /V %~dp0minlogon.exe .\windows\system32\winlogon.exe>>xpcli.log
FOR %%A IN (
%~dp0BaseRegistry\DEFAULT
%~dp0BaseRegistry\SAM
%~dp0BaseRegistry\SECURITY
%~dp0BaseRegistry\SOFTWARE
%~dp0BaseRegistry\SYSTEM
) DO ECHO %%A>>xpcli.log&copy /V %%A .\windows\system32\config\>>xpcli.log
popd
echo.

echo All done! ((Maybe! ;)))

PAUSE

GOTO :EOF

:MissingFile
CLS
ECHO File %~dpfx1 is missing, please add it to 
ECHO %~dp1
ECHO and press any key
ECHO Ctrl+C to abort
SET MISSING_FLAG=1
PAUSE
GOTO :EOF

:Get_Source
CLS
ECHO NO Source was found, please enter full path to a local \I386 directory:
ECHO Example:
ECHO F:\Myfiles\XP\I386
SET /P Source=
IF NOT %Source%.==. (
IF NOT EXIST %Source%\NTDETECT.COM (
Set Source=
GOTO :Get_Source
)
)
GOTO :EOF

:Copy_or_Expand
SET File_full=%1
IF "%File_full:~0,1%"=="" (
IF %~x1.==. MD %~dp0ROOT\%File_full:~1%
GOTO :EOF
)
IF "%File_full:~0,1%"=="#" GOTO :EOF


::I SERVe Kentucky Fried Chicken Hot!
IF /I "%File_full:~0,13%"=="WINDOWS\Apps\" (
SET This_Source=%~dp0Apps
SET DIR_Name=%File_full:WINDOWS\Apps=!This_Source!%
xcopy /I /S /R /V /E /K /F /C /H !DIR_Name! %~dp0ROOT\%File_full%>>xpcli.log
)


SET File=%~nx1
SET Fil_=%File:~0,-1%_
IF EXIST %Source%\%File% copy %Source%\%File% %~dp0ROOT\%File_full%>>xpcli.log
IF EXIST %Source%\%Fil_% expand %Source%\%Fil_% %~dp0ROOT\%File_full%>>xpcli.log
IF EXIST %~dp0ADDONS\%File% copy /Y %~dp0ADDONS\%File% %~dp0ROOT\%File_full%>>xpcli.log
IF EXIST %~dp0ADDONS\REGFILES\%File% copy /Y %~dp0ADDONS\REGFILES\%File% %~dp0ROOT\%File_full%>>xpcli.log


GOTO :EOF